#pragma once

#include "Object3d.h"
#include "Mesh.h"
#include "MathLib.h"

class Currents : public Object3d
{
protected:
	struct Particle
	{
		Vec3f			offset_pos;
		Vec3f			pos;
		Vec3f			old_pos;
		float			t;
	};
	typedef std::list<Particle>		Particles; 
public:
	typedef std::list<Currents*>	Vector;
public:
	Currents(const Vec3f& p1,const Vec3f& p2,const Vec3f& p3,const Vec3f& p4,const float strength,const float radius);
	virtual ~Currents(void);

	virtual	void	draw();
	virtual void	anim(const float t);

			Vec3f	get_pos(const float t) const;
			bool	get_force(const Vec3f& pos,Vec3f& force);
			Vec3f	get_derivative(const float t) const;

	inline	Vec3f	get_center() { return (_p[0]+_p[1]+_p[2]+_p[3])*0.25f; }

protected:
	Mesh<VertexPC>*	_mesh;
	Particles		_particles;
	Vec3f			_p[4];
	Color			_color[2];
	float			_strength;
	float			_radius;
	float			_choose[4][4];
	Vec3f			_approx[10];
	Vec3f			_approx_dir[10];
	float			_approx_len[10];
public:
	static	Vector	g_currents;
};
