#include "GameEnemy.h"
#include "GameScreen.h"
#include "Launcher.h"
#include "Sound.h"

GameEnemy::Vector	GameEnemy::g_enemies;

GameEnemy::GameEnemy(const char* type,const char* name,const long model_id) : GameObject(type,name,model_id)
{
	g_enemies.push_back(this);
}

GameEnemy::~GameEnemy(void)
{
	auto it=g_enemies.begin();
	while (it!=g_enemies.end())
	{
		if ((*it)==this)
		{
			g_enemies.erase(it);
			break;
		}
		++it;
	}
}

void GameEnemy::deal_damage(const float damage)
{
	_health-=damage;
	if (_health<=0.0f)
	{
		((GameScreen*)SCREEN)->spawn_explosion(_pos,5.0f,this);
		set_draw(true);
		_inc_alpha=-0.01f;

		if (options_get_sound()) SOUND->play("explosion01",options_get_fx_volume());

		((GameScreen*)SCREEN)->add_xp((int)(get_xp_value()*((GameScreen*)SCREEN)->get_xp_factor()),_pos);
	}
}

void GameEnemy::finished_alpha_fade(const float inc_alpha)
{
	if ((_health<=0.0f) && (inc_alpha<0.0f))
	{
		((GameScreen*)SCREEN)->remove_object3d(this);
	}
}
