#include "GameObject.h"
#include "GameScreen.h"
#include "BlitManager3d.h"
#include "Material.h"

GameObject::GameObject(const char* type,const char* name,const long model_id) : ModelObj3d(type,name)
{
	_collision_point_count=0;
	_max_health=1000.0f;
	_health=_max_health;
	_inc_alpha=0.0f;
	_radius=0.0f;
	set_mesh(model_id);
	make_material_copy();
}

GameObject::~GameObject(void)
{
}

void GameObject::anim(const float t)
{
	if (_inc_alpha!=0.0f)
	{
		Color c=_material->get_material_color();
		c.a=c.a+_inc_alpha*t;

		if ((_inc_alpha<0.0f) && (c.a<=0.0f))
		{
			finished_alpha_fade(_inc_alpha);
			_inc_alpha=0.0f;
			c.a=0.0f;
		}
		else if ((_inc_alpha>0.0f) && (c.a>=1.0f))
		{
			finished_alpha_fade(_inc_alpha);
			_inc_alpha=0.0f;
			c.a=1.0f;
		}
		if (c.a!=1.0f) { _material->enable_pass(PASS_ALPHA); _material->disable_pass(PASS_SOLID); _material->set_alpha(true,D3DBLEND_SRCALPHA,D3DBLEND_INVSRCALPHA); _material->set_z_write(false); }
		else { _material->disable_pass(PASS_ALPHA); _material->enable_pass(PASS_SOLID); _material->set_alpha(false,D3DBLEND_SRCALPHA,D3DBLEND_INVSRCALPHA); _material->set_z_write(true); }

		_material->set_material_color(c.r,c.g,c.b,c.a);
	}
}

void GameObject::draw()
{
	ModelObj3d::draw();

	/*Vec3f p;
	for (int i=0; i<_collision_point_count; i++)
	{
		_ori.rotate_point(p,_collision_points[i]);
		p=p+_pos;

		BLIT3D->add_triangle(p,p+Vec3f(1.0f,1.0f,0.0f),p+Vec3f(1.0f,-1.0f,0.0f),Color(1,1,0,1));
		BLIT3D->add_triangle(p,p+Vec3f(-1.0f,1.0f,0.0f),p+Vec3f(-1.0f,-1.0f,0.0f),Color(1,1,0,1));
	}//*/
}

bool GameObject::check_collision(Vec3f& collision_point,int& collision_point_index)
{
	for (int i=0; i<_collision_point_count; i++)
	{
		if (check_collision(i,collision_point))
		{
			collision_point_index=i;
			return true;
		}
	}

	return false;
}

bool GameObject::check_collision(const int index,Vec3f& collision_point)
{
	Vec3f p;
	_ori.rotate_point(p,_collision_points[index]);
	p=p+_pos;
	if (((GameScreen*)SCREEN)->check_collision(p,collision_point)) 
	{
		return true;
	}

	return false;
}

void GameObject::set_max_health(const float f)
{
	if (_max_health==_health) _health=f;
	_max_health=f;
}
