#pragma once
#include "GameObject.h"

class Weapon_MachineGun;
class ParticleSystem3d;

class Player :
	public GameObject
{
public:
	Player(const float ammo);
	virtual ~Player(void);

	virtual	void	anim(const float t);
	virtual	void	draw();

	inline	Vec3f	get_velocity() { return _velocity; }
	inline	float	get_minerals() { return _minerals; }
	inline	float	get_ammo() { return _ammo; }
	inline	float	get_ammo_percentage() { return _ammo/100.0f; }
			bool	close_to_landing();
			bool	is_landing_speed();
	inline	bool	is_landed() { return _landed; }
	inline	void	set_input(const bool b) { _input=b; }
	inline	void	set_minerals(const float f) { _minerals=f; }
			void	stop_thruster();

public:
	Vec3f				_velocity;
	float				_tractor_alpha;
	float				_tractor_alpha_inc;
	float				_minerals;
	float				_max_ammo;
	float				_ammo;
	bool				_landed;
	Weapon_MachineGun*	_weapon;
	bool				_input;
	long				_thruster_snd;
	float				_thruster_vol;
	long				_tractor_snd;
	ParticleSystem3d*	_ps;
};

