#pragma once

#include "Mesh.h"
#include "Defs.h"

class GameObject;

class Weapon_MachineGun
{
protected:
	struct Shot
	{
		Vec3f		_pos;
		Vec3f		_old_pos;
		Vec3f		_inc;
		float		_life;
	};
	typedef std::list<Shot>	Shots;
public:
	Weapon_MachineGun(const float life,const float speed,const float heating,const float heating_recover);
	virtual ~Weapon_MachineGun(void);

	virtual bool	is_available();
	virtual void	weapon_anim(const float t);
	virtual	bool	is_melee() { return false; }
	virtual	float	get_range() { return _life*_speed; }
	virtual	void	weapon_draw();
			void	shoot(const Vec3f& source_point,const Vec3f& target_point,GameObject* owner);

protected:
	Shots			_shots;
	float			_life;
	float			_speed;
	float			_heat_factor;
	float			_heat_drain;
	float			_heat;
	bool			_overheat;
	long			_shot_count;
	Mesh<VertexPC>*	_mesh;
	unsigned long	_last_shot;
	unsigned long	_last_hit;
};
