#pragma once
#include "Object3d.h"

class Camera :
	public Object3d
{
public:
	Camera(const char* name);
	virtual ~Camera(void);

	virtual	void	draw();
	inline	void	set_fov(const float fov) { _fov=fov; }
	inline	void	set_aspect(const float a) { _aspect=a; }
			void	set();
			void	set_lookat(const Vec3f& from,const Vec3f& to);
			void	extract_ray(const unsigned long mpx,const unsigned long mpy,Vec3f& ray_origin,Vec3f& ray_dir);
			bool	inside(const Vec3f& pmin,const Vec3f& pmax);

public:
	float	_fov;
	float	_aspect;
	float	_near_plane;
	float	_far_plane;
public:
	// For 3d blits
	Vec3f	_y_plane_right_axis;
	Vec3f	_right_axis;
	Vec3f	_up_axis;
	Vec3f	_normal_axis;
	Vec3f	_y_plane_normal_axis;
};

extern Camera*	CAMERA3D;
