#ifndef __DEFS_H
#define __DEFS_H

#include <cstdint>

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <string>
#include <vector>
#include <map>
#include <list>

#ifdef USE_DINPUT8
#define	DIRECTINPUT_VERSION         0x0800
#include <dinput.h>

extern LPDIRECTINPUT8	LPDI;
#endif

#ifdef USE_D3D9
#include <d3d9.h>
#include <d3dx9.h>

typedef LPDIRECT3DTEXTURE9				TextureID;
typedef LPDIRECT3DSURFACE9				ZBufferID;
typedef LPDIRECT3DSURFACE9				SurfaceID;
typedef LPDIRECT3DVERTEXDECLARATION9	VertexDeclaration;
#define TEXTURE_INVALID	NULL
#define DECL_INVALID	NULL

#else
typedef enum { LDRS_LIGHTING,
			   LDRS_CULLMODE,
			   LDRS_COLORVERTEX,LDRS_AMBIENTMATERIALSOURCE,LDRS_DIFFUSEMATERIALSOURCE,LDRS_EMISSIVEMATERIALSOURCE,
			   LDRS_POINTSPRITEENABLE,LDRS_POINTSCALEENABLE,LDRS_POINTSIZE_MIN,LDRS_POINTSCALE_A,LDRS_POINTSCALE_B,LDRS_POINTSCALE_C,
			   D3DRS_ALPHABLENDENABLE,D3DRS_SRCBLEND,D3DRS_DESTBLEND,
			   LDRS_ZWRITEENABLE } LDRENDERSTATETYPE;
typedef enum { } LDTEXTURESTAGESTATETYPE;
typedef enum { } LDSAMPLERSTATETYPE;
typedef enum { } LDPRIMITIVETYPE;
#define TextureHandler unsigned long

#endif

#include "MathLib.h"

typedef void (*MouseEventCallback)(unsigned long msg,unsigned long wparam,unsigned long lparam);

void set_mouse_event_callback(MouseEventCallback callback);
MouseEventCallback get_mouse_event_callback();

#define MAX_LIGHT	8
#define MAX_TEX		8
#define USE_SHADERS	1

typedef enum { BLIT_NORMAL, BLIT_PREMULTALPHA, BLIT_ADD, BLIT_ADD_NOZWRITE, BLIT_SRCALPHA_ONE, BLIT_NORMAL_NOZWRITE } BlitMode;
typedef enum { PASS_SOLID=0, PASS_ALPHA=1, PASS_SOLID_NO_EMISSIVE=2, PASS_SOLID_ONLY_EMISSIVE=3, PASS_MAKE32BIT=0xFFFFFFFF } PassType;

#endif