#pragma once

#include "Gfx.h"
#include "Mesh.h"

class FSEffect
{
protected:
public:
	FSEffect(const std::string& effect_object_name,const int n_stages,const bool own_z,const float scale_rt);
	virtual ~FSEffect(void);

	void	begin();
	void	end(const D3DBLEND src_blend=D3DBLEND_ONE,const D3DBLEND dest_blend=D3DBLEND_ZERO);
	void	run(const std::string& effect_name);

	void	set_constant(const std::string& constant_name,const Vec4f& val);

protected:
	void	actual_run_effect(const std::string& effect_name);

protected:
	int			_n_stages;
	TextureID*	_rt;
	SurfaceID*	_rt_surface;
	int*		_rt_ids;
	ZBufferID	_zbuffer;
	int			_current_index;
	BaseMesh*	_mesh;
	Material*	_material;
};

