#pragma once
#include "Object3d.h"

typedef enum { LIGHT_NONE=0, LIGHT_POINT=1, LIGHT_SPOT=2, LIGHT_DIR=3 } LightType;

class Light :
	public Object3d
{
public:
	Light(const char* name);
	virtual ~Light(void);

	virtual	void		draw();
	inline	void		set_type(const LightType t) { _type=t; }
	inline	LightType	get_type() { return _type; }
	inline	Color		get_color() { return _color; }
	inline	void		set_color(const Color& c) { _color=c; }
	inline	void		set_color(const float r,const float g,const float b,const float a) { _color.set(r,g,b,a); }
	inline	float		get_range_start() { return _range.x; }
	inline	float		get_range_end() { return _range.y; }
	inline	void		set_range(const float start,const float end) { _range.set(start,end); }
	inline	float		get_inner_cone() { return _cone.x; }
	inline	float		get_outer_cone() { return _cone.y; }
	inline	void		set_cone(const float inner,const float outer) { _cone.set(inner,outer); }

protected:
	void	update();

	friend class Gfx;
#ifdef USE_D3D9
protected:
	D3DLIGHT9	_light;
#endif

protected:
	LightType	_type;
	Color		_color;
	Vec2f		_range;
	Vec2f		_cone;
};
