#include "ModelObj3d.h"
#include "Gfx.h"
#include "Mesh.h"
#include "BlitManager3d.h"
#include "ModelManager.h"

ModelObj3d::ModelObj3d(const char* type,const char* name) : Object3d(type,name)
{
	_mesh=NULL;
	_mesh_bound=false;
	_model=-1;
	_material=NULL;
}

ModelObj3d::~ModelObj3d(void)
{
	if (_mesh)
	{
		if (_mesh_bound) delete _mesh;
		_mesh=NULL;
	}
	if (_material)
	{
		delete _material;
		_material=NULL;
	}
}

void ModelObj3d::draw()
{
	if (!_draw) return;
	if ((!_mesh) && (_model==-1)) return;

	BLIT3D->flush();

	if (_mesh) 
	{
		GFX->set_world_transformation(0,_pos.x,_pos.y,_pos.z,_ori,_scale.x,_scale.y,_scale.z);
		_mesh->draw(_material);
	}
	else MODEL_MANAGER->draw(_model,_pos,_ori,_scale,NULL,_material);
}

void ModelObj3d::anim(const float t)
{

}

BaseMesh* ModelObj3d::get_mesh() 
{ 
	if (_mesh) return _mesh; 
	else if (_model==-1) return NULL;

	return MODEL_MANAGER->get_mesh(_model);
}

void ModelObj3d::make_material_copy()
{
	if (_material) delete _material;

	if (_mesh) _material=_mesh->get_material();
	else
	{
		BaseMesh* mesh=MODEL_MANAGER->get_mesh(_model);
		if (mesh) _material=mesh->get_material();
	}

	if (_material)
	{
		_material=_material->clone();
	}
}
