#include "MouseCursor.h"
#include "TextureManager.h"
#include "Gfx.h"

MouseCursor*	CURSOR=NULL;

MouseCursor::MouseCursor(const char* cursor_texture) : Sprite("mouse_cursor")
{
	_pos.z=0.01f;
	int img=TEXTURES->find_by_name(cursor_texture);
	set_image(img);
	set_size((float)TEXTURES->get_size_x(img),(float)TEXTURES->get_size_y(img));
	set_hotspot(_size.x*0.5f,_size.y*0.5f);
	_prev_cursor=CURSOR;
	CURSOR=this;

	set_priority(-1000.0f);
}

MouseCursor::~MouseCursor(void)
{
	CURSOR=_prev_cursor;
}

void MouseCursor::anim(const float t)
{
	Sprite::anim(t);

	POINT pt;
	GetCursorPos(&pt);
	_pos.x=(float)pt.x;
	_pos.y=(float)pt.y;

	RECT	full, client;
	long	clientw, clienth;
	HWND	window=GFX->get_window();

	GetClientRect(window,&client);
	clientw=client.right-client.left;
	clienth=client.bottom-client.top;
	AdjustWindowRect(&client,GFX->get_window_style(),false); 
	GetWindowRect(window,&full);

	RECT	e;
	e.left=full.left-client.left;
	e.top=full.top-client.top;
	e.right=full.left-client.left+clientw;
	e.bottom=full.top-client.top + clienth;

	float	sx=(float)(e.right-e.left);
	float	sy=(float)(e.bottom-e.top);

	_pos.x=(GFX->get_virtual_resolution().x)*(pt.x-e.left)/sx;
	_pos.y=(GFX->get_virtual_resolution().y)*(pt.y-e.top)/sy;
}
