#include "NavPath.h"
#include "BlitManager3d.h"
#include "Gfx.h"

NavPath::NavPath()
{
};

NavPath::~NavPath(void)
{

}

void NavPath::clear()
{
	_source=_target;
	_path_pos_len=0;
	_path_waypoint=0;
}

void NavPath::draw()
{
	if (GFX->get_pass()!=PASS_ALPHA) return;

	for (int i=1; i<_path_pos_len; i++)
	{
		Vec3f p=_path_pos[i];
		Vec3f last_pos=_path_pos[i-1];
		p.y=last_pos.y;
		Vec3f d=p-last_pos; d.normalize();
		Vec3f p1=last_pos+Vec3f(d.z,0.1f,-d.x)*0.5f;
		Vec3f p2=last_pos-Vec3f(d.z,0.1f,-d.x)*0.5f;
		p.y=p1.y=p2.y=0.1f+(p.y+p1.y+p2.y)/3.0f;

		BLIT3D->add_triangle(p,p1,p2,Color(0.0f,1.0f,1.0f,0.8f));
	}
}
