
#ifndef __RENDERENV_H
#define __RENDERENV_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Defs.h"

class RenderEnv
{
public:
	struct Light
	{
		unsigned char	_type:2;
	};
	struct Props
	{
		// View
		unsigned char	_fog_linear:1;
		// Light
		unsigned char	_light_count:3;
		Light			_lights[MAX_LIGHT];
		// Material
		unsigned char	_map[MAX_TEX/8];
		unsigned char	_alpha_test_enabled:1;
		// Mesh
		unsigned char	_normal:1;
		unsigned char	_psize:1;
		unsigned char	_color0:1;
		unsigned char	_color1:1;
		unsigned char	_tex_coord_count;
		unsigned char	_reserved:1;
		// Other
		unsigned char	_pass;
		unsigned char	_reserved_other[3];
	};
public:
	RenderEnv();
	RenderEnv(const RenderEnv& env);
	RenderEnv(const RenderEnv* env);
	~RenderEnv();

	void	reset();
	void	set(const RenderEnv& env);
	void	set(const RenderEnv* env);

	std::string	get_key();

public:
	Props			_props;
};

inline bool operator<(const RenderEnv& e1,const RenderEnv& e2)
{
	uint64_t* ptr1=(uint64_t*)&(e1);
	uint64_t* ptr2=(uint64_t*)&(e2);

	if ((*ptr1)==(*ptr2))		
	{
		ptr1++; ptr2++;				// Second QWORD
	}

	return (*ptr1)<(*ptr2);
}

#endif
