
#ifndef __RndGenerator_H
#define __RndGenerator_H

#define MERS_N   624
#define MERS_M   397
#define MERS_R   31
#define MERS_A   0x9908B0DF

class RndGenerator  
{
public:
	RndGenerator(const long seed=123456789);
	virtual ~RndGenerator();

	void			set_seed(const long seed);
	unsigned long	get_random();
	long			get_random_i(const long min,const long max);
	float			get_random_f(const float min,const float max);

protected:
	unsigned long	_mt[MERS_N];                   // state vector
	long			_mti;                          // index into mt
};

extern RndGenerator	g_rnd;

#endif // !defined(AFX_SBRNDGENERATOR_H__2FEC8641_9D99_4EA3_90E7_D8A95F4885AD__INCLUDED_)
