#pragma once

#include "Object3d.h"
#include "Mesh.h"
#include "MathLib.h"

class Sparks : public Object3d
{
protected:
	struct Particle
	{
		Vec3f			pos;
		Vec3f			old_pos;
		unsigned long	color1;
		unsigned long	color2;
		Vec3f			speed;
		float			life;
		float			max_life;
	};
	typedef std::list<Particle>		Particles; 
public:
	Sparks();
	virtual ~Sparks(void);

	virtual	void	draw();
	virtual void	anim(const float t);

			void			new_explosion(const Vec3f& pos,const float speed,const long n_particles,const float max_life,const unsigned long color1,const unsigned long color2);

protected:
	Mesh<VertexPC>*	_mesh;
	Particles		_particles;
};

