#pragma once
#include "object3d.h"
#include "TextureManager.h"

class SpriteAnim3d;

class Sprite3d :
	public Object3d
{
public:
	Sprite3d(const char* type,const char* name);
	virtual ~Sprite3d(void);

			void		set_image(long img);
	inline	long		get_image() { return _current_image; }

	inline	void		set_size(const Vec2f& s) { _size=s; }
	inline	Vec2f		get_size() { return _size; }

	inline	void		set_color(float r,float g,float b,float a) { _color.set(r,g,b,a); }
	inline	Color		get_color() { return _color; }

	inline	void		set_ground(const bool b) { _ground=b; }
	inline	void		set_perp(const bool b) { _perp=b; }

			void		set_frame(const long frame);
	inline	long		get_frame() { return _frame; }

	inline	void		set_frame_uv(const float u1,const float v1,const float u2,const float v2) { _frame_uv.set(u1,v1,u2,v2); }
	inline	void		set_frame_uv(const Rect& uv) { _frame_uv=uv; }
	inline	Rect		get_frame_uv() { return _frame_uv; }

	virtual	void		anim(const float t);
	virtual	void		draw();

			void		play_animation(const char* anim_name,const bool force_start=false,const char* next_anim=NULL);

	inline	void		set_blit_mode(const BlitMode mode) { _blit_mode=mode; }
	inline	void		set_billboard(const bool b) { _billboard=b; }

protected:
	long			_current_image;
	Color			_color;
	Vec2f			_size;
	long			_frame;
	Rect			_frame_uv;
	bool			_billboard;
	bool			_ground;
	bool			_perp;
	Vec3f			_hotspot;
	SpriteAnim3d*	_current_anim;
	std::string		_next_anim;
	BlitMode		_blit_mode;
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class SpriteAnim3d
{
public:
	SpriteAnim3d(Sprite3d* spr,TextureManager::Anim* anim);
	virtual ~SpriteAnim3d();

			void		anim(const float t);
	inline	const char*	get_name() { return _anim->name; }
	inline	bool		is_ended() { return _frame_index==-1; }

protected:
	TextureManager::Anim*	_anim;
	Sprite3d*				_sprite;
	float					_frame_time;
	int						_frame_index;
};
