
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Drawable.h"

class UIButton : public Drawable
{
public:
	UIButton(const char* img_name,const Vec3f& pos,const std::string& tooltip,const std::string& callback_id,const std::string& snd_hover);
	virtual ~UIButton();

		virtual	void		draw();
		virtual	void		anim(const float t);
				bool		is_inside();
				bool		is_inside(const Vec3f& vec);
		inline	std::string	get_callback_id() { return _callback_id; }
		inline	void		set_available(const bool b) { _available=b; if (_available) _color.a=0.8f; else _color.a=0.3f; }
		inline	bool		is_available() { return _available; }
		inline	std::string	get_tooltip() { return _tooltip; }
		inline	void		set_color(const Color& c) { _color=c; }
		inline	void		set_id(const long id) { _id=id; }
		inline	long		get_id() { return _id; }
		inline	void		set_background_color(const Color& c) { _background_color=c; }
		inline	void		set_foreground_color(const Color& c) { _foreground_color=c; }

protected:
	long		_img;
	std::string	_callback_id;
	bool		_available;
	std::string	_tooltip;
	bool		_was_inside;
	long		_id;
	Color		_background_color;
	Color		_foreground_color;
	std::string	_snd_hover;
};
typedef std::vector<UIButton*>	UIButtons;
